﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        string SourceFile, DestFile;
        List<int> colLenghts = new List<int>();
        List<string> colNames = new List<string>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadComboBox(comboBoxFormatDest);
            LoadComboBox(comboBoxFormatSource);            
        }

        private void LoadComboBox(ComboBox cb )
        {
            cb.Items.Clear();
            EncodingInfo[] encodingList  =  Encoding.GetEncodings();
            for (int i = 0; i < encodingList.Length; i++)
                cb.Items.Add(encodingList[i].Name);

        }

        private void buttonBrowseSource_Click(object sender, EventArgs e)
        {
            if(openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                SourceFile = openFileDialog1.FileName;
            }
        }

        private void buttonBrowseDest_Click(object sender, EventArgs e)
        {
            if(saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                DestFile = saveFileDialog1.FileName;
            }
        }

        private void buttonReadColumns_Click(object sender, EventArgs e)
        {
            colLenghts.Clear();
            colNames.Clear();            
            using (StreamReader sr = new StreamReader(DestFile, Encoding.GetEncoding(comboBoxFormatDest.SelectedItem.ToString()), false))
            {

                int charsRead;
                char[] buffer = new char[128 * 1024];
                bool startedColumns = false;
                bool endColumns = false;
                bool startedRows = false;
                bool endRows = false;
                while ((charsRead = sr.ReadBlock(buffer, 0, buffer.Length)) > 0)
                {
                    if (endRows)
                        break;

                    char[] curBuff = new char[charsRead];
                    for (int p = 0; p < charsRead; p++)
                    {
                        curBuff[p] = buffer[p];
                    }
                    //buffer.CopyTo(curBuff, 0);
                    string curBuffStr = new string(curBuff);
                    string[] colInfo = curBuffStr.Split('|');
                    for (int i = 0; i < colInfo.Length; i++)
                    {
                        if (endRows)
                            break;

                        if (colInfo[i] == "HL")
                        {
                            startedColumns = true;
                        }
                        if (startedColumns && !endColumns)
                        {
                            if((!colInfo[i].EndsWith("DL") && !colInfo[i].EndsWith("TL")))
                                colNames.Add(colInfo[i]);
                            else
                                colNames.Add("FinalFill");
                        }
                        if ((colInfo[i].EndsWith("DL") || colInfo[i].EndsWith("TL")) && startedRows)
                        {
                            endRows = true;
                            colLenghts.Add(colInfo[i].Length - 2);
                            continue;
                        }
                        if ((colInfo[i].EndsWith("DL") || colInfo[i].EndsWith("TL")) && !endRows && !startedRows)
                        {
                            endColumns = true;
                            startedRows = true;
                            colLenghts.Add(2);                            
                            continue;
                        }
                        if (endColumns && startedRows && !endRows)
                        {
                            colLenghts.Add(colInfo[i].Length);
                        }
                    }
                }
            }
            richTextBox1.Text = "";
            for (int y = 0; y < colNames.Count; y++)
            {
                richTextBox1.Text += colNames[y] + "(" + colLenghts[y].ToString() + ")\r\n";
            }
            int TotalColumnLength = 0;
            for (int i = 0; i < colLenghts.Count; i++)
            {
                TotalColumnLength += colLenghts[i];
            }
            TotalColumnLength += colLenghts.Count - 1;
            richTextBox1.Text += "Total Row Length:" + TotalColumnLength.ToString();
        }

        private void buttonSaveLF_Click(object sender, EventArgs e)
        {
            int TotalColumnLength = 0;
            if(colLenghts.Count > 1)
            {
                for(int i = 0; i < colLenghts.Count; i++)
                {
                    TotalColumnLength += colLenghts[i];
                }
                TotalColumnLength += colLenghts.Count -1;
            }
            else
            {
                return;
            }
            using (StreamReader sr = new StreamReader(DestFile, Encoding.GetEncoding(comboBoxFormatDest.SelectedItem.ToString()), false))
            {
                using (StreamWriter sw = new StreamWriter(DestFile+".LF.txt", false, Encoding.GetEncoding(comboBoxFormatDest.SelectedItem.ToString())))
                {
                    int charsRead;
                    char[] buffer = new char[TotalColumnLength];
                    while ((charsRead = sr.ReadBlock(buffer, 0, buffer.Length)) > 0)
                    {
                        char[] curBuff = new char[charsRead];
                        for (int p = 0; p < charsRead; p++)
                        {
                            curBuff[p] = buffer[p];
                        }                        
                        string curBuffStr = new string(curBuff);
                        string[] colInfo = curBuffStr.Split('|');
                        for(int q =0; q < colInfo.Length; q++)
                        {
                            if(!(colInfo[0] == "TL"))
                            {
                                //sw.Write("\"");
                                sw.Write(colInfo[q]);
                                //sw.Write("\"");
                                if (q == colInfo.Length-1)
                                    sw.Write("\r\n");
                                else
                                    sw.Write("|");

                                /*if (colInfo[q].StartsWith("\0\0") && colInfo[q].EndsWith("DL"))
                                {
                                    sw.Write("\r\n");
                                    sw.Write("\"");
                                    sw.Write(colInfo[q]);
                                    sw.Write("\"");
                                    sw.Write("|");
                                }
                                else
                                {
                                    sw.Write("\"");
                                    sw.Write(colInfo[q]);
                                    sw.Write("\"");
                                    sw.Write("|");
                                }
                                */
                            }
                            else
                            {
                                break;
                            }
                        }
                        //sw.Write(buffer, 0, charsRead);
                        //sw.Write("\r\n");
                    }
                }
            }
        }

        private void buttonConvert_Click(object sender, EventArgs e)
        {//IBM037 -> us-ascii
            using (StreamReader sr = new StreamReader(SourceFile,Encoding.GetEncoding(comboBoxFormatSource.SelectedItem.ToString()),false))
            {
                using (StreamWriter sw = new StreamWriter(DestFile, false, Encoding.GetEncoding(comboBoxFormatDest.SelectedItem.ToString())))
                 {
                     int charsRead;
                     char[] buffer = new char[128 * 1024];
                     while ((charsRead = sr.ReadBlock(buffer, 0, buffer.Length)) > 0)
                     {
                         sw.Write(buffer, 0, charsRead);
                     }
                 }
            }
            
            MessageBox.Show("Complete");
        }
    }
}
